#include "graph_lib.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>

#define LOG_DEBUG 1
#define LOG_WARN 2
#define LOG_ERR 3
#define LOG_LEVEL LOG_WARN

int main(int argc, char *argv[])
{

	int num_graph;
	
	if (argc != 4 || ( ( strcmp( argv[1], "tgf" ) != 0 ) && ( strcmp( argv[1], "g6" ) != 0 ) && ( strcmp( argv[1], "wilma" ) != 0 ) ) ) {
		printf( "USAGE: %s format input_file number_of_graph\n", argv[0] );
		printf( "          formats: tgf wilma g6\n" );
		return 1;
	} else {
		num_graph = atoi( argv[3] );
		if ( num_graph<0 ) {
			printf( "       number_of_graph - must be non-negative integer" );
			return 1;
		}
	}

	
	char input_file_name[60];

	sprintf( input_file_name, "%s", argv[2] );
	FILE *input_file = fopen( input_file_name, "r" );
	if (NULL == input_file ) {
		msg (LOG_ERR, "failed to open input file for reading ");
		exit(1);	
	}; 
		
	graph_t *graph;	

	skip_lines( num_graph, input_file );
	
	graph = g_create_from_file( input_file );

	
	if ( strcmp( argv[1], "tgf" ) == 0 ) {
		g_dump_tgf( graph );
	}

	if ( strcmp( argv[1], "wilma" ) == 0 ) {
		g_dump_wilma( graph );
	}
	
	if ( strcmp( argv[1], "g6" ) == 0 ) {
		g_write_to_file( graph, stdout );
	}
	
	
	
//	g_write_to_file_sparse( graph, stdout );	

	g_destroy( &graph );

	
	fclose( input_file );
//	fclose( output_file );
	
		
	return 0;

}
