#include <stdio.h>
#include <stdlib.h>


int edges[9][9];


void dump( int *order, int num_items ) {
	int i;
	int colors[10];

	for (i = 0; i<num_items; i++) {
		colors[i] = edges[order[i]][order[(i+1)%num_items]];
	}	

	if( are_duplicates( colors, num_items ) )
		return;
	
	for (i = 0; i<num_items; i++) {
	 	printf("%d ", order[i] );
	}
	printf("\n");

}

int are_duplicates( int *order, int num_items ) {
	int i;
	int used[100];
	for (i = 0; i<100; i++ ) {
		used[i] = 0;
	}

	for (i = 0; i<num_items; i++ ) {
		if (used[order[i]] == 1) {
			return 1;
		} else {
			used[order[i]] = 1;
		}
	}
	return 0;
}



int orig_coloring[] = { 0, 2, 4, 3, 1, 5, 6, 7, 1, 2,
					    4, 6, 3, 7, 8, 3, 0, 5, 8, 4, 
						6, 1, 8, 7, 5, 0, 7, 6, 8, 5,
						0, 2, 4, 1, 2, 3 };



int main(int argc, char *argv[]) {	
	//all permutations	
	int num_items = 9;
	
	
	
	
	int order[num_items];
	
	int i, j, position, count;
	
	
	count=0;
	for (i=0; i<8; i++) {
		edges[i][i] = -1;
		for (j=i+1; j<9; j++) {
			edges[i][j]=orig_coloring[count];
			edges[j][i]=orig_coloring[count];
			count++;
		}
	}
	
	for (i=0; i<num_items; i++) {
		order[i] = 0;
	}
	
	position = 0;

	while(1) {
		if (position < 0) {
			//no more permutations
			break;
		}
		
		if (position == num_items) {
			dump( order, num_items );
			position--;
			order[position]++;
			continue;
		}
		
		if (order[position]==num_items) {
				order[position]=0;
				position--;
				order[position]+=1;
				continue;
		}
		
		if (are_duplicates( order, position+1 ) ) {
			order[position]++;
			continue;
		} else {
			position++;	
			continue;
		}
	}

	return 0;
}

